# HG changeset patch
# User Rafael Laboissiere <rafael@laboissiere.net>
# Date 1668529531 10800
#      Tue Nov 15 13:25:31 2022 -0300
# Branch typos
# Node ID 190b337fa15fd15b0e0b97fa0c2eeedd226b65ee
# Parent  9f4a9dd4a6ee34ddc6e8d0a87d0c703782af7358
Fix typos and grammatical mistakes in text exposed to the user

* liboctave/numeric/svd.cc: "occured" -> "occurred"

* libgui/src/settings-dialog.ui: "Commmand" -> "Command"

* libgui/src/shortcut-manager.cc: "allows to" -> "allows one to"

* libgui/languages/*.ts: "Commmand" -> "Command" and "allows to" ->
  "allows one to"

diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/be_BY.ts
--- a/libgui/languages/be_BY.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/be_BY.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -5452,7 +5452,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
@@ -6416,7 +6416,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/ca_ES.ts
--- a/libgui/languages/ca_ES.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/ca_ES.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -4514,7 +4514,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
@@ -5476,7 +5476,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/de_DE.ts
--- a/libgui/languages/de_DE.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/de_DE.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -3822,7 +3822,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation>Umschalttaste hinzufügen
 (Ermöglicht die Verwendung von Zahlen)</translation>
     </message>
@@ -4788,7 +4788,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation>Deaktiviere Tastenkürzel zur Aktivierung
 von Menüs, wenn das Befehlsfenster den Fokus hat</translation>
     </message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/en_US.ts
--- a/libgui/languages/en_US.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/en_US.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -3678,7 +3678,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
@@ -4639,7 +4639,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/es_ES.ts
--- a/libgui/languages/es_ES.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/es_ES.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -3829,7 +3829,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation>Añadir modificador para la tecla Shift
 (están permitidas teclas numéricas)</translation>
     </message>
@@ -4798,7 +4798,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation>Desactivar los accesos directos al menñu de la ventana principal cuando el foco esté en la ventana de comandos</translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/eu_ES.ts
--- a/libgui/languages/eu_ES.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/eu_ES.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -5459,7 +5459,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
@@ -6430,7 +6430,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/fr_FR.ts
--- a/libgui/languages/fr_FR.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/fr_FR.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -3809,7 +3809,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation>Ajouter un la touche Shift</translation>
     </message>
     <message>
@@ -4776,7 +4776,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation>Désactiver les accélérateurs de menus dans la fenêtre principale lorsque la fenêtre de commande à le focus</translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/hu_HU.ts
--- a/libgui/languages/hu_HU.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/hu_HU.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -4536,7 +4536,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation>Shift módosító hozzáadása
 (lehetővé teszi számgombok bevitelét)</translation>
     </message>
@@ -5499,7 +5499,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation>A főablak menüinek menügyorsítóinak letiltása, ha a Parancsablak fókuszban van</translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/it_IT.ts
--- a/libgui/languages/it_IT.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/it_IT.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -4540,7 +4540,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
@@ -5507,7 +5507,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/ja_JP.ts
--- a/libgui/languages/ja_JP.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/ja_JP.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -4523,7 +4523,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
@@ -5465,7 +5465,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/lt_LT.ts
--- a/libgui/languages/lt_LT.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/lt_LT.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -4508,7 +4508,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
@@ -5470,7 +5470,7 @@
     </message>
     <message>
         <location line="+250"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/nl_NL.ts
--- a/libgui/languages/nl_NL.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/nl_NL.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -5536,7 +5536,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation>Voeg Shiftbewerking toe
 (om getallen in te kunnen voeren)</translation>
     </message>
@@ -6504,7 +6504,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation>Schakel menusneltoetsen van hoofdvenster uit als Command Windows het focus heeft</translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/pt_BR.ts
--- a/libgui/languages/pt_BR.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/pt_BR.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -3779,7 +3779,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
@@ -4746,7 +4746,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/pt_PT.ts
--- a/libgui/languages/pt_PT.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/pt_PT.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -4495,7 +4495,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
@@ -5461,7 +5461,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/ru_RU.ts
--- a/libgui/languages/ru_RU.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/ru_RU.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -4544,7 +4544,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation>Добавить модификатор Shift
 (позволяет использовать клавиши с цифрами)</translation>
     </message>
@@ -5512,7 +5512,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/tr_TR.ts
--- a/libgui/languages/tr_TR.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/tr_TR.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -4581,7 +4581,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation>Shift değiştirici ekle
 (sayı tuşlarının girilmesine izin verir)</translation>
     </message>
@@ -5545,7 +5545,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation>Komut Penceresi odaklandığında ana pencere menülerinin menü hızlandırıcılarını devre dışı bırakın</translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/uk_UA.ts
--- a/libgui/languages/uk_UA.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/uk_UA.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -4434,7 +4434,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
@@ -5395,7 +5395,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/languages/zh_CN.ts
--- a/libgui/languages/zh_CN.ts	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/languages/zh_CN.ts	Tue Nov 15 13:25:31 2022 -0300
@@ -4565,7 +4565,7 @@
     <message>
         <location line="+3"/>
         <source>Add Shift modifier
-(allows to enter number keys)</source>
+(allows one to enter number keys)</source>
         <translation>添加 Shift 修改器
 （允许输入数字键）</translation>
     </message>
@@ -5508,7 +5508,7 @@
     </message>
     <message>
         <location line="+117"/>
-        <source>Disable menu accelerators of main window menus when Commmand Window has focus</source>
+        <source>Disable menu accelerators of main window menus when Command Window has focus</source>
         <translation>当命令窗口获取焦点时禁用主窗口菜单的菜单快捷键</translation>
     </message>
     <message>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/src/settings-dialog.ui
--- a/libgui/src/settings-dialog.ui	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/src/settings-dialog.ui	Tue Nov 15 13:25:31 2022 -0300
@@ -2602,7 +2602,7 @@
 interference with readline key strokes.</string>
                  </property>
                  <property name="text">
-                  <string>Disable menu accelerators of main window menus when Commmand Window has focus</string>
+                  <string>Disable menu accelerators of main window menus when Command Window has focus</string>
                  </property>
                 </widget>
                </item>
diff -r 9f4a9dd4a6ee -r 190b337fa15f libgui/src/shortcut-manager.cc
--- a/libgui/src/shortcut-manager.cc	Sun Nov 13 13:00:16 2022 -0500
+++ b/libgui/src/shortcut-manager.cc	Tue Nov 15 13:25:31 2022 -0300
@@ -677,7 +677,7 @@
 
         QCheckBox *shift
           = new QCheckBox (tr ("Add Shift modifier\n"
-                               "(allows to enter number keys)"));
+                               "(allows one to enter number keys)"));
 
         shift->setStyleSheet
           ("QCheckBox::indicator { subcontrol-position: left top; }");
diff -r 9f4a9dd4a6ee -r 190b337fa15f liboctave/numeric/svd.cc
--- a/liboctave/numeric/svd.cc	Sun Nov 13 13:00:16 2022 -0500
+++ b/liboctave/numeric/svd.cc	Tue Nov 15 13:25:31 2022 -0300
@@ -827,7 +827,7 @@
           if (iwork[2] == 1)
             (*current_liboctave_warning_with_id_handler)
               ("Octave:convergence", "svd: (driver: GEJSV) "
-               "Denormal occured, possible loss of accuracy.");
+               "Denormal occurred, possible loss of accuracy.");
 
           if (info < 0)
             (*current_liboctave_error_handler)